module BackendInfo
  extend self
  @@status : Int32 = 0
  @@exvpp_url : String = ""

  def self.check_backends
    check_videoplayback_proxy()
    check_companion()
  end

  def check_companion
    begin
      response = HTTP::Client.get "#{CONFIG.invidious_companion.sample.private_url}/healthz"
      if response.status_code == 200
        @@status = 1
        check_videoplayback_proxy()
      else
        @@status = 0
      end
    rescue
      @@status = 0
    end
  end

  def check_videoplayback_proxy
    begin
      info = HTTP::Client.get "#{CONFIG.invidious_companion.sample.private_url}/info"
      exvpp = JSON.parse(info.body)["external_videoplayback_proxy"]?.try &.to_s
      if exvpp.nil? || exvpp.empty?
        @@status = 2
        return
      else
        begin
          exvpp_health = HTTP::Client.get "#{exvpp}/health"
          if exvpp_health.status_code == 200
            @@status = 2
            return
          end
        rescue
          @@status = 1
        end
      end
    rescue
    end
  end

  def get_videoplayback_proxy
    begin
      response = HTTP::Client.get "#{CONFIG.invidious_companion.sample.private_url}/info"
      exvpp_url = JSON.parse(response.body)["external_videoplayback_proxy"].to_s
      @@exvpp_url = exvpp_url
    rescue
    end
  end

  def get_status
    return @@status
  end

  def get_exvpp
    return @@exvpp_url
  end
end
